cdef cypclass Base:
    int a
    int b

    __init__(self, int a, int b):
        self.a = a
        self.b = b


    __init__(self, int a):
        self.__init__(a, 0)

    __init__(self):
        self.__init__(0, 0)


cdef cypclass Derived(Base):

    int c

    __init__(self, int a, int b, int c):
        self.c = c


cpdef cypclass AltDerived(Base):

    __init__(self, int a, int b):
        self.a = a + b
        self.b = b - a


cpdef void test():
    cdef Base base = Base(4, 2)
    cdef Derived derived1 = Derived(4)
    cdef Derived derived2 = Derived(4, 2)
    cdef Derived derived3 = Derived(4, 2, 1)
    cdef AltDerived alt_derived = AltDerived(4, 2)


    print(base.a, base.b)

    print(derived1.a, derived1.b, derived1.c)

    print(derived2.a, derived2.b, derived2.c)

    print(derived3.a, derived3.b, derived3.c)

    print(alt_derived.a, alt_derived.b)
