cdef cypclass Base:
    int base


cdef cypclass Derived1(Base):
    int derived1
    void setBase(self, int arg):
        self.base = arg


cdef cypclass Derived2(Base):
    int derived2
    void setBase(self, int arg):
        self.base = arg


cdef cypclass Diamond(Derived1, Derived2):
    int diamond


cdef void printD1(Derived1 d1) with gil:
    print(d1.derived1, d1.base)

cdef void printD2(Derived2 d2) with gil:
    print(d2.derived2, d2.base)


cpdef void test():
    o = Diamond()
    o.derived1 = 42
    o.derived2 = 4242
    Derived1.setBase(o, 4)
    Derived2.setBase(o, 2)

    printD1(o)

    printD2(o)

