cpdef cypclass SomeClass:
    int a
    double b

    int __int__(self):
        return self.a

    double __double__(self):
        return self.b



cdef cypclass SomeContainer:
    SomeClass some_object


    bint __bool__(self):
        return self.some_object is not NULL

    int __int__(self):
        if self:
            return <int> self.some_object
        else:
            return 0


    double __double__(self):
        if self:
            return <double> self.some_object
        else:
            return 0.0


cpdef void test():
    contained = SomeClass()
    contained.a = 42
    contained.b = 4.2

    container = SomeContainer()
    container.some_object = contained

    print(<bint> container, <int> container, <double> container)
